/* ez-blob.h: Serialising description and serialiser.

   Copyright (C) 2019 Michael Zucchi

   This program is free software: you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public License
   as published by the Free Software Foundation, either version 3 of
   the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this program. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdint.h>
#include <ctype.h>

#include "ez-blob.h"

void ez_blob_dump(const ez_blob *blob, const char *prefix) {
	const char *data = blob->eb_data;
	size_t size = blob->eb_size;
	
	for (int i=0;i<size;i+=16) {
		fputs(prefix, stdout);
		printf(" %04x:", i);
		for (int j=0;j<16;j++) {
			if (i+j<size)
				printf(" %02x", data[i+j] & 0xff);
			else
				fputs("   ", stdout);
		}
		fputs("  ", stdout);
		for (int j=0;j<16;j++) {
			if (i+j<size)
				putchar(isprint(data[i+j]) ? data[i+j] : '.');
			else
				putchar(' ');
		}
		putchar('\n');
	}
}
