
#include <pthread.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <stdio.h>

#include "ez-port.h"

/* This is really not much of a test */

static void *start(void *d) {
	ez_port *port = d;
	char *msg;

	do {
		msg = ez_port_take(port);
		printf("got: %s\n", msg);
		sleep(1);
	} while (strcmp(msg, "quit") != 0);

	return port;
}

int main(int argc, char **argv) {
	pthread_t tid;
	ez_port *port = ez_port_new(4);

	pthread_create(&tid, NULL, start, port);

	for (int i=0;i<10;i++) {
		printf("send: bob\n");
		ez_port_put(port, "bob");
	}
	sleep(20);
	for (int i=0;i<10;i++) {
		printf("send: jane\n");
		ez_port_put(port, "jane");
		sleep(2);
	}
	ez_port_put(port, "quit");

	pthread_join(tid, NULL);

	ez_port_free(port);
	
	return 0;
}


#if 0

// This is an implementation of a bounded message queue for threads
// but doesn't allow poll() or select().
// probably not worth it

typedef struct ez_port ez_port;
typedef struct ez_msg ez_msg;

struct ez_port {
	ez_list list;
	pthread_mutex_t mutex;
	pthread_cond_t cond_take;
	pthread_cond_t cond_put;
	unsigned int limit;
	volatile unsigned int size;
};

void ez_port_init(ez_port *port, int limit) {
	ez_list_init(&port->list);
	pthread_mutex_init(&port->mutex, NULL);
	pthread_cond_init(&port->cond_take, NULL);
	pthread_cond_init(&port->cond_put, NULL);
	port->limit = limit;
	port->size = 0;
}

void *ez_port_poll(ez_port *port) {
	ez_msg *m;
	int signal;
	
	pthread_mutex_lock(&port->mutex);
	signal = port->size == port->limit;
	m = ez_list_remhead(&port->list);
	pthread_mutex_unlock(&port->mutex);
	if (signal)
		pthread_cond_signal(&port->cond_put);		
}

void *ez_port_take(ez_port *port) {
	ez_msg *m;
	int signal;
	
	pthread_mutex_lock(&port->mutex);
	signal = port->size == port->limit;
	while ((m = ez_list_remhead(&port->list)) == NULL)
		pthread_cond_wait(&port->cond_take, &port->mutex);
	pthread_mutex_unlock(&port->mutex);
	if (signal)
		pthread_cond_signal(&port->cond_put);		

	return m;
}

void ez_port_put(ez_port *port, void *m) {
	int signal;
	
	pthread_mutex_lock(&port->mutex);
	while (port->size == port->limit)
		pthread_cond_wait(&port->cond_put, &port->mutex);
	signal = port->size == 0;
	ez_list_addtail(&port->list, m);
	pthread_mutex_unlock(&port->mutex);

	if (signal)
		pthread_cond_signal(&port->cond_take);
}

#endif
