
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <assert.h>

#include "ez-tree.h"

/*
  Another bunch of shitty tests.
 */

struct node {
	struct ez_node tn;

	int value;
};

struct lnode {
	struct ez_node tn;

	int value;
};

static int node_cmp(const void *a, const void *b) {
	const struct node *c = a, *d = b;
	return c->value - d->value;
}

static __inline__ int node_balance(struct ez_node *n) __attribute__((always_inline));

static __inline__ int node_balance(struct ez_node *n) {
	int i = n->u.tree.link[0];
	return i << 30 >> 30;
}

static int check_balance(struct ez_node *n) {
	if (n) {
		int l = check_balance(ez_node_left(n));
		int r = check_balance(ez_node_right(n));
		int b = node_balance(n);

		assert(r-l == b);
		return 1 + (l > r ? l : r);
	} else
		return 0;
}

static int count_nodes(struct ez_node *n) {
	int c = 0;
	while (n) {
		c += 1;
		c += count_nodes(ez_node_left(n));
		n = ez_node_right(n);
	}
	return c;
}

static void get_none(ez_tree *t, int i) {
	struct node k = { .value = i };
	assert(ez_tree_get(t, &k) == NULL);
}

static void get_exists(ez_tree *t, int i) {
	struct node k = { .value = i };
	struct node *n;

	n = ez_tree_get(t, &k);
	assert(n != NULL);
	assert(n->value == i );
}

static void del_exists(ez_tree *t, int i) {
	struct node k = { .value = i };
	struct node *n;

	n = ez_tree_remove(t, &k);
	assert(n != NULL);
	assert(n->value == i );
	free(n);
}

static void put_new(ez_tree *t, int i) {
	struct node *n = malloc(sizeof(*n));

	n->value =i;

	assert(ez_tree_put(t, n) == NULL);
}

struct word {
	ez_node node;
	int index;
	char *word;
};

static int word_cmp(const void *ap, const void *bp) {
	const struct word *a = ap, *b = bp;

	return strcmp(a->word, b->word);
}

static void word_free(void *ap){
	struct word *a = ap;

	free(a->word);
	free(a);
}

static ez_tree *read_words(struct word ***array, int *asize) {
	FILE *fp = fopen("/usr/share/dict/words", "r");
	char word[256];
	int count = 0;
	ez_tree *tree = malloc(sizeof(*tree));

	ez_tree_init(tree, word_cmp);

	if (array) {
		*asize = 16384;
		*array = malloc((*asize) * sizeof(void *));
	}

	if (!fp)
		fp = fopen("words", "r");
	if (!fp) {
		printf("test skipped: cannot open /usr/share/dict/words or ./words\n");
		return 0;
	}
	while (fgets(word, 256, fp)) {
		size_t len = strlen(word);
		if (len > 0) {
			struct word *e = malloc(sizeof(*e));

			word[len-1] = 0;
			e->word = strdup(word);

			if (array) {
				if (count >= *asize) {
					*asize = *asize * 2;
					*array = realloc(*array, *asize * sizeof(void *));
				}
				e->index = count;
				(*array)[count] = e;
			}

			e = ez_tree_put(tree, e);
			if (e) {
				printf("duplicate! %s\n", e->word);
				word_free(e);
			}
			count += 1;
		}
	}
	fclose(fp);

	*asize = count;

	return tree;
}

void words(void) {
	int count;
	ez_tree *tree = read_words(NULL, &count);

	assert(count_nodes(ez_tree_root(tree)) == count);
	assert(count_nodes(ez_tree_root(tree)) == ez_tree_size(tree));
	check_balance(ez_tree_root(tree));

	ez_tree_clear(tree, word_free);
	free(tree);
}

void words2(void) {
	int count = 0;
	struct word **words;
	ez_tree *t = read_words(&words, &count);

	int limit = count / 3;
	int seen =0;
	ez_tree_scan scan;
	struct word key = { .word = "bullshit" };

	for (struct word *n = ez_tree_scan_init_key(t, &scan, EZ_LINK_LEFT, EZ_LINK_RIGHT, &key);  n && seen < limit; seen++) {
		struct word *w = n;

		n = ez_tree_scan_remove(&scan, EZ_LINK_LEFT);

		words[w->index] = NULL;
		word_free(w);
	}
	check_balance(ez_tree_root(t));
	assert(count_nodes(ez_tree_root(t)) == count - seen);
	assert(count_nodes(ez_tree_root(t)) == ez_tree_size(t));

	free(words);
	ez_tree_clear(t, word_free);
	free(t);
}

int main(int argc, char **argv) {
	ez_tree tree = EZ_INIT_TREE(tree, node_cmp);
	ez_tree *t = &tree;

	get_none(t, 0);
	assert(ez_tree_root(t) == NULL);
	assert(ez_tree_size(t) == 0);

	for (int i=0;i<7;i++) {
		put_new(t, i);
	}
	assert(ez_tree_root(t) != NULL);
	assert(ez_tree_size(t) == 7);
	assert(count_nodes(ez_tree_root(t)) == ez_tree_size(t));

	check_balance(ez_tree_root(t));
	for (int i=-10;i<10;i++) {
		if (i >= 0 && i < 7)
			get_exists(t, i);
		else
			get_none(t, i);
	}

	ez_tree_clear(t, free);
	assert(ez_tree_size(t) == 0);
	assert(ez_tree_root(t) == NULL);

	for (int i=0;i<1027;i++) {
		put_new(t, i);
	}
	assert(ez_tree_root(t) != NULL);
	assert(ez_tree_size(t) == 1027);
	check_balance(ez_tree_root(t));

	for (int i=-10;i<1030;i++) {
		if (i >= 0 && i < 1027)
			get_exists(t, i);
		else
			get_none(t, i);
	}
	ez_tree_clear(t, free);

	//
	int count, c;

	count = 0;
	ez_tree_init(&tree, node_cmp);
	for (int i=0;i<1027;i++) {
		put_new(t, i);
		count++;
	}
	for (int i=37;i<301;i++) {
		del_exists(t, i);
		get_none(t, i);
		count--;
	}
	check_balance(ez_tree_root(t));
	assert(count == ez_tree_size(t));
	assert(count_nodes(ez_tree_root(t)) == ez_tree_size(t));

	//
	ez_tree_scan scan;
	int j;
	j = 0;
	c = 0;
	for (struct node *n = ez_tree_scan_init(t, &scan, EZ_LINK_RIGHT); n ; n = ez_tree_scan_next(&scan)) {
		assert(j == n->value);
		if (j == 36)
			j = 301;
		else
			j++;
		c++;
	}
	assert(c == count);

	j = 1026;
	c = 0;
	for (struct node *n = ez_tree_scan_init(t, &scan, EZ_LINK_LEFT); n ; n = ez_tree_scan_next(&scan)) {
		assert(j == n->value);
		if (j == 301)
			j = 36;
		else
			j--;
		c++;
	}
	assert(c == count);

	//
	ez_tree_clear(t, free);
	for (int i=0;i<100;i++) {
		put_new(t, i * 7);
	}
	for (int i=0;i<100;i++) {
		struct node k = { .value = i };
		struct node *n = ez_tree_scan_init_key(t, &scan, EZ_LINK_LEFT, EZ_LINK_RIGHT, &k);

		assert(n != NULL);
		assert(n->value >= i);
		assert(n->value < i + 7);
	}
	for (int i=0;i<100;i++) {
		struct node k = { .value = i };
		struct node *n = ez_tree_scan_init_key(t, &scan, EZ_LINK_RIGHT, EZ_LINK_LEFT, &k);

		assert(n != NULL);
		assert(n->value <= i);
		assert(n->value > i - 7);
	}
	ez_tree_clear(t, free);

	//
	words();
	words2();

	return 0;
}






// this is a known working version for comparison

#if 0


void *ez_tree_removex(ez_tree *tree, const void *key) {
	struct ez_tree_scan_info stack[32];
	struct ez_tree_scan_info *sp = stack;
	ez_tree_node *p = (void *)tree->root.link[1];
	struct ez_tree_scan_info *si;

	// Find node, record how we got there

	*sp++ = (struct ez_tree_scan_info){ &tree->root, 1 };
	while (p) {
		int cmp = tree->node_cmp(key, p);
		int cmpi = cmp > 0;

		*sp++ = (struct ez_tree_scan_info){ p, cmpi };

		if (cmp == 0)
			break;
		else
			p = node_link(p, cmpi);
	}

	if (!p)
		return NULL;

#ifdef SPEW
	si = stack;
	printf("pre-remove stack: p=%p\n", p);
	while (si < sp) {
		printf(" %p [%p %p %d] %d\n", si->node, ez_node_left(si->node), ez_node_right(si->node), node_balance(si->node), si->link);
		si += 1;
	}
	fflush(stdout);
#endif
	// Binary tree remove and adjust balance factors
	ez_tree_node *r = ez_node_right(p);

	if (!r) {
		node_set_link(sp[-2].node, sp[-2].link, ez_node_left(p));
		sp -= 1;
	} else {
		ez_tree_node *s = ez_node_left(r);

		if (!s) {
			node_set_link(r, 0, ez_node_left(p));
			node_set_balance(r, node_balance(p));
			node_set_link(sp[-2].node, sp[-2].link, r);
			sp[-1] = (struct ez_tree_scan_info) { r, 1 };
		} else {
			ez_tree_node *q;
			struct ez_tree_scan_info *psp = sp;

			*sp++ = (struct ez_tree_scan_info){ r, 0 };
			while ((q = ez_node_left(s))) {
				*sp++ = (struct ez_tree_scan_info){ s, 0 };
				r = s;
				s = q;
			}

			node_set_link(s, 0, ez_node_left(p));
			node_set_link(r, 0, ez_node_right(s));
			node_set_link(s, 1, ez_node_right(p));
			node_set_balance(s, node_balance(p));

			node_set_link(psp[-2].node, psp[-2].link, s);
			psp[-1] = (struct ez_tree_scan_info){ s, 1 };
		}
	}

#ifdef SPEW
	si = stack;
	printf("post-remove stack: \n");
	while (si < sp) {
		printf(" %p [%p %p %d] %d\n", si->node, ez_node_left(si->node), ez_node_right(si->node), node_balance(si->node), si->link);
		si += 1;
	}
	//printf("tree\n");
	//dump(tree->root.link[1], 1);
#endif

	// Rebalance tree
	// basic code from libavl but paramterised as in Knuth
	si = sp-1;
	while (si > stack) {
		struct ez_tree_node *y = si->node;
		int ai = si->link;
		int aj = ai ^ 1;
		int a = ai * 2 - 1;
		int yb = node_balance(y);

#ifdef SPEW
		printf("y %p [%p %p] balance=%d ai=%d a=%d\n", y, ez_node_left(y), ez_node_right(y), node_balance(y), ai, a);
		fflush(stdout);
#endif
		if (a == yb)
			node_set_balance(y, 0);
		else if (yb == 0) {
			node_set_balance(y, -a);
			break;
		} else {
			struct ez_tree_node *x = node_link(y, aj);
			int xb = node_balance(x);

#ifdef SPEW
			printf("x %p [%p %p] balance=%d\n", x, ez_node_left(x), ez_node_right(x),  node_balance(x));
			fflush(stdout);
#endif
			if (xb == a) {
				// double rotate
				struct ez_tree_node *w = node_link(x, ai);
				int wb = node_balance(w);
#ifdef SPEW
				printf("w %p [%p %p] balance=%d\n", w, ez_node_left(w), ez_node_right(w), node_balance(w));
				fflush(stdout);
#endif
				x->link[ai] = node_link(w, aj);
				w->link[aj] = (intptr_t)x;
				y->link[aj] = node_link(w, ai);
				w->link[ai] = (intptr_t)y;

				node_set_balance(y, wb == -a ? +a : 0);
				node_set_balance(x, wb == +a ? -a : 0);
				node_set_balance(w, 0);

				node_set_link(si[-1].node, si[-1].link, w);
			} else {
				// single rotate
				y->link[aj] = node_link(x, ai);
				x->link[ai] = (intptr_t)y;
				node_set_link(si[-1].node, si[-1].link, x);
				if (xb == 0) {
					node_set_balance(x, +a);
					node_set_balance(y, -a);
					break;
				} else {
					node_set_balance(x, 0);
					node_set_balance(y, 0);
				}
			}
		}

		si -= 1;
	}

	//si = stack;
	//printf("stack: \n");
	//while (si < sp) {
	//	printf(" %p %d\n", si->node, si->node->value);
	//	si += 1;
	//}
	//printf("tree\n");
	//dump(tree->root.link[1], 1);

	return p;
}

#endif
